// @Plugin : GoldTracker - A simple gold tracking plugin
// @Author : PePPeRmix (original author Misanthrope)
// @Version : 2.0
// @Date : 17.10.2014

using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Linq.Expressions;
using System.Net;
using System.Threading;
using System.Windows.Forms;
using System.Windows.Media;
using System.Xml.Linq;

using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.Helpers;
using Styx.Plugins;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;

namespace PluginTemplate
{ 


    public class PluginTemplate : HBPlugin
    {
        private static LocalPlayer Me { get { return StyxWoW.Me; } }

        private static ulong _lastTarget = 0;

        private static double startgold = 0;
        private static DateTime starttime = DateTime.Now;
        private static DateTime nextmoney = DateTime.Now;
		
        private static string pname = "null";

        private static double GetMoney()
        {
            List<string> known = Lua.GetReturnValues("return GetMoney()", "GetMoney.lua");
            double gold = (ulong.Parse(known[0])) / 10000;
            return gold;
        }
		private static string GetPName()
        {
            List<string> known = Lua.GetReturnValues("return GetUnitName('player')", "GetUnitName.lua");
            return known[0];
        }

        #region Overrides
        public override string Name { get { return "GoldTracker"; } }
        public override string Author { get { return "PePPeRmix"; } }
        public override Version Version { get { return new Version(1, 0); } }
        public override bool WantButton { get { return true; } }
        public override string ButtonText { get { return "GoldTracker"; } }        
        public override void OnButtonPress()
        {
            // new Form1().ShowDialog();
        } 

        public PluginTemplate()
        {
            BotEvents.OnBotStarted += BotEvents_OnBotStart;
            BotEvents.OnBotStopped += BotEvents_OnBotStop;
        }
        #endregion


        #region Logging
        public static void slog(LogLevel logLvl, Color color, string format, params object[] args)
        { Logging.Write(logLvl, color, "[GoldTracker]: " + format, args); }

        public static void slog(string format, params object[] args)
        { slog(LogLevel.Normal, Colors.DodgerBlue, format, args); }

        #endregion


        #region BotEvents
        public void BotEvents_OnBotStart(EventArgs args)
        {
			
			starttime = DateTime.Now;
			nextmoney = DateTime.Now;
            startgold = GetMoney();
            slog("-----------------------------------");
            slog("----- Starting gold: {0:0.00} -----", startgold);
            slog("-----------------------------------");
			pname = GetPName();
        }

        public void BotEvents_OnBotStop(EventArgs args)
        {
            slog("----- Result for this session -----");
            nextmoney = DateTime.Now.AddSeconds(10);
            double currentgold = GetMoney();
            double elapsedtime = (DateTime.Now - starttime).TotalHours;
            if (elapsedtime > 0)
            {
                slog("Starting gold: {0:0.00} - Current gold: {1:0.00}", startgold, currentgold);
                slog("Total Won: {0:0.00} - Gold/hour: {1:0.00}", currentgold - startgold, (currentgold - startgold) / elapsedtime);
            }
            slog("-----------------------------------");
        }
        #endregion


        public override void Pulse()
        {
            returnMoney();
        }

        private static bool IsMounted
        {
            get
            {
                switch (StyxWoW.Me.Shapeshift)
                {
                    case ShapeshiftForm.FlightForm:
                    case ShapeshiftForm.EpicFlightForm:
                        return true;
                }
                return StyxWoW.Me.Mounted;
            }
        }

        private static void returnMoney()
        {
           if(DateTime.Now > nextmoney)
            {
                        nextmoney = DateTime.Now.AddSeconds(10);
                        double currentgold = GetMoney();
                        double elapsedtime = (DateTime.Now - starttime).TotalHours;
                        if (elapsedtime > 0)
                        {
							TreeRoot.GoalText = string.Format("Starting gold: {0:0.00} - Current gold: {1:0.00} - Gold/hour: {2:0.00} PlayerName: {3}",
                            startgold, currentgold, (currentgold - startgold) / elapsedtime, pname);
                        }
            }
        }
    }
}